#include "endgame.h"


char expstep[esdp1][3];
//from / to / steps to go
int expindex;
//0: indicator for the next step ,0 for not used
//rest: the pre-calculated steps

struct endlib * addendlibc(struct endlib * node,char id,char from,char to,char steps){
  struct endlib * tmp;
  tmp=(struct endlib*)malloc(sizeof(struct endlib));
  tmp->id=id;
  tmp->neighbor=node->child;
  tmp->child=NULL;
  tmp->steps[0]=from;
  tmp->steps[1]=to;
  tmp->steps[2]=steps;
  node->child=tmp;
  return tmp;
}
struct endlib * addendlibn(struct endlib * node,char id,char from,char to,char steps){
  struct endlib * tmp;
  tmp=(struct endlib*)malloc(sizeof(struct endlib));
  tmp->id=id;
  tmp->neighbor=node->neighbor;
  tmp->child=NULL;
  tmp->steps[0]=from;
  tmp->steps[1]=to;
  tmp->steps[2]=steps;
  node->neighbor=tmp;
  return tmp;
}
// found ==> -1, need add child
//           -2, the new node should be the first child
//           0, cant found, add neighbor
//return the found node or the previous node before it should be located
struct endlib * findendlibnode(struct endlib * currentnode,int id,int * found){
  struct endlib * tmp=currentnode;
  if(tmp->child!=NULL){//if there are child found
    if(id>tmp->child->id){
      (*found)=-1;
    }else{
      tmp=tmp->child;
      if(id==tmp->id){
        (*found)=1;
      }else{
        while((tmp->neighbor!=NULL)&&(tmp->neighbor->id>=id)){
          tmp=tmp->neighbor;
        }//stop only if equal or not found
        if(tmp->id==id){
          (*found)=1;
        }else{
          (*found)=0;
        }
      }
    }
  }else{//no child at all...
    (*found)=-1;
  }
  return tmp;
}

void learning(char arrayi[10],char from,char to,char steps){
  int i;
  FILE * out=fopen(TREEFILE,"a");

  for(i=0;i<10;i++){
    fprintf(out,"%3d ",arrayi[i]);
  }
  fprintf(out,"%3d %3d %3d\n",from,to,steps);
  fclose(out);
}

int addendlibentry(char arrayi[10],char from,char to,char steps,
                    struct endlib * currentroot,int learn){
  int i,found;
  struct endlib * tmp=currentroot;
  for(i=9;i>-1;i--){
    tmp=findendlibnode(tmp,arrayi[i],&found);
    if(found==-1){//add child case
      if(i==0){
        tmp=addendlibc(tmp,(char)arrayi[0],(char)from,(char)to,(char)steps);
        if(learn){
          learning(arrayi,from,to,steps);
        }
        return 1;
      }else{
        tmp=addendlibc(tmp,(char)arrayi[i],-1,-1,-1);
      }
    }else if(found==0){//add neighbor case
      if(i==0){
        tmp=addendlibn(tmp,(char)arrayi[0],(char)from,(char)to,(char)steps);
        if(learn){
          learning(arrayi,from,to,steps);
        }
        return 1;
      }else{
        tmp=addendlibn(tmp,(char)arrayi[i],-1,-1,-1);
      }
    }//nothing to do for found
  }
  return 0;
}

struct endlib * solsearchext(char ownpos[10]){
  struct endlib * tmp=root;
  char i;
  int found;

  for(i=9;i>-1;i--){
    tmp=findendlibnode(tmp,ownpos[i],&found);
    if(found!=1){
      return NULL;
    }
  }
  if(tmp->steps[0]==-1){
    return NULL;
  }else{
    if(tmp->steps[2]==-1){
      return NULL;
    }else{
      return tmp; //tmp->steps[2];
    }
  }
}
void endgameinit(void){
  expindex=-1;
}

int solsearch(char posC[2][10]){
  struct endlib * tmp=root;
  char i;
  int found;
  for(i=9;i>-1;i--){
    tmp=findendlibnode(tmp,posC[0][i],&found);
    if(found!=1){return 0;}
  }
  if(tmp->steps[0]==-1){
    return 0;
  }else{
    for(i=0;i<10;i++){//find key
      if(posC[0][i]==tmp->steps[0]){break;}//found la
    }
    //valid check
    if(pcheck(posC[0],posC[1],tmp->steps[0],tmp->steps[1],i)){
      posC[0][i]=tmp->steps[1];//update
      sortP(posC[0],i);
      printf("%d %d\n",tmp->steps[0]+1,tmp->steps[1]+1);
      fflush(stdout);
      return 1;
    }else{
      return 0;
    }
  }
}
void readendtree(void){
  int i;
  char arrayi[13];
  FILE * tree;
  
  //init of roots 
  root=(struct endlib*)malloc(sizeof(struct endlib));
  root->id=-1;
  root->neighbor=NULL;
  root->child=NULL;
  root->steps[0]=-1;

  if ((tree=fopen(TREEFILE,"r"))==NULL){
    tree=fopen(TREEFILE,"w");
    fclose(tree);
  }else{
    while(feof(tree)==0){
      for(i=0;i<13;i++){
        fscanf(tree,"%d",arrayi+i);
      }
      addendlibentry(arrayi,arrayi[10],arrayi[11],arrayi[12],root,0);
    }
    fclose(tree);
  }
}

void showsubtree(struct endlib * subroot){
  if(subroot->neighbor!=NULL){
    showsubtree(subroot->neighbor);
  }
  if(subroot->child!=NULL){
    showsubtree(subroot->child);
  }
  printf("%d\n",subroot->id);
}

void killsubtree(struct endlib * subroot){
  if(subroot->neighbor!=NULL){
    killsubtree(subroot->neighbor);
  }
  if(subroot->child!=NULL){
    killsubtree(subroot->child);
  }
  free(subroot);
}
