/********************** imports *************************/
#include "give.h"

/**************** function prototypes *******************/
void loopcheckinit(void);
int win(char status[10]);
double maxvalue(char ownstate[10],char oppstate[10],int curr_lev,
             char to,char key,double a,double *b);
double minvalue(char ownstate[10],char oppstate[10],int curr_lev,
             char to,char key,double *a,double b);

/****************** function bodies *********************/

void setturnfactor(char posC[2][10]){
  /*
  if(turn<= 5){tfactor=1;return;}
  if(turn<=13){tfactor=2;return;}
  if(turn<=20){tfactor=3;return;}
  else        {tfactor=1;return;}
  */
  int i;

  if(turn<= 5){tfactor=1;return;}
  tfactor=3;
  for(i=0;i<10;i++){
    if(posC[0][i]>10){
      tfactor-=0.2;
    }
    if(posC[1][i]<10){
      tfactor+=0.1;
    }
  }
}

/*
function  : loopcheckinit
use       : to initiate the global variable used for loop check
argument  : void
return    : void
*/
void loopcheckinit(void){
  int i;
  for(i=0;i<CHECKSIZE;i++){
    loopcheck[i][0]=-1-i;
    loopcheck[i][1]=-1-i;
    loopcheck[i][2]=-1-i;
  }
}

/*
function  : win
use       : to verify whether a given status a win game status
argument  : char status[10]
return    : int 1 - true
                0 - false
remark    : the status is not necessarily sorted
*/
int win(char status[10]){
  int sum=0;
  int i;
  for (i=0;i<10;i++){
    sum+=status[i];
  }
  return (sum==GAME);
}

double negascout(int depth,double alpha,double beta,
                 char ownstate[10],char oppstate[10],
                 char to,char key,int * sollev){
  int i,total;
  double t,a,b;
  char list[300][3];
  int marks[300];
  char curroppstate[10];char currownstate[10];
  int retlev=NOSOL;

#ifdef TABLEMODE
  int steps;
  struct endlib * tmpsol;
  memcpy(currownstate,ownstate,10);currownstate[key]=to;sortP(currownstate,key);
  if(((depth%2)==0)&&((tmpsol=solsearchext(currownstate))!=NULL)){
    (*sollev)=(sd-depth)/2+1+tmpsol->steps[2];
    return -MAXX;
  }
#endif
  if(depth==0){
    memcpy(currownstate,ownstate,10);currownstate[key]=to;
    return -efunction1(currownstate,oppstate,ownstate[key],to,key);
  }
  for(i=0;i<10;i++){
    curroppstate[9-i]=120-ownstate[i];
    currownstate[9-i]=120-oppstate[i];
  }
  curroppstate[9-key]=120-to;

  sortP(curroppstate,(char)(9-key));
  if(((depth%2)==0)&&(curroppstate[9]==9)){
    return -MAXX;
  }
  //movegen
  total=movegen(currownstate,curroppstate,depth,list,marks,6);
//edit code from "http://www.zib.de/reinefeld/Research/nsc.html"
  a=alpha;b=beta;
  for(i=0;i<total;i++){
    t=-negascout(depth-1,-b,-a,
                    currownstate,curroppstate,
                      list[i][1],list[i][2],&retlev);
    if((*sollev)>retlev){
        //printf("update1 sollev %d to %d at %d\n",(*sollev),retlev,depth);
      (*sollev)=retlev;
    }
    if((t>a)&&(t<beta)){  //fail low
      a=-negascout(depth-1,-beta,-t,
                    currownstate,curroppstate,
                      list[i][1],list[i][2],&retlev);     // re-search 
      if((*sollev)>retlev){
        (*sollev)=retlev;
      }
    }
    if(a<t)a=t;
    if(a>=beta){
      return a;                            // cut-off 
    }
    b=a+1;                      // set new null window 
  }
  return a;
}

void give2(char posC[2][10]){
  double alpha=MINN,beta=MAXX;
  int total;
  int i;
  int marks[300];
  char list[300][3];
  double t,a,b;
  int index=-1;
  double curr_best=MINN;
  char alert=0;
  char from, to, key;
  int depth;
  int tmpi=0;
  int sollev=NOSOL,retlev=NOSOL;
  int steps;
  struct endlib * tmpsol;

  setturnfactor(posC);
  //check loop
  for(i=2;i<CHECKSIZE;i++){                   //check 1 same pos
    if(loopcheck[0][0]==loopcheck[i][0]){
      if(loopcheck[0][1]==loopcheck[i][1]){
        if(loopcheck[0][2]==loopcheck[i][2]){
          if((posC[0][0]<10)&&(posC[1][9]<111)){
            alert=1;
            break;
          }
        }
      }
    }
  }
  if(alert){
    for(key=1;key<10;key++){//found concern range
      if(posC[0][key]>=10){
        break;
      }
    }
    //special version of movegen=> movegenT
    //move gen???
    if(total=movegenT(posC[0],posC[1],list,key,loopcheck[0][0])<=0){
      total=movegen(posC[0],posC[1],sd,list,marks,6);
    }
  }else{
    //normal version of movegen or end game version
    if(posC[0][0]>posC[1][9]){
      depth=esd;oppfactor=0;
      total=movegen(posC[0],posC[1],depth,list,marks,4);//printf("4");
    }else{
      depth=sd;oppfactor=1/2;
      total=movegen(posC[0],posC[1],depth,list,marks,6);//printf("6");
    }
  }
  a=alpha;b=beta;
  for(i=0;i<total;i++){
#ifdef TABLEMODE
    if((tmpsol=solsearchext(posC[0]))!=NULL){
      for(key=0;key<10;key++){//found concern range
        if(posC[0][key]==tmpsol->steps[0]){
          break;
        }
      }
      if(pcheck(posC[0],posC[1],tmpsol->steps[0],tmpsol->steps[1],key)){
        //update actively
        posC[0][key]=tmpsol->steps[1];
        sortP(posC[0],key);
        printf("%d %d\n",tmpsol->steps[0]+1,tmpsol->steps[1]+1);
        fflush(stdout);
        return;
      }
    }
#endif
    outfrom=list[i][0];
    outto=list[i][1];

    //version 1
    if(outfrom<10) bonus=1+0.2*slowmove; else 
    if(list[i][2]==0) bonus=3; else bonus=1;

    t=-negascout(depth-1,-b,-a,posC[0],posC[1],list[i][1],list[i][2],&retlev);

    if(sollev>retlev){
      sollev=retlev;
      tmpi=i;
    }
    if((t>a)&&(t<beta)){
      /* re-search */
      a=-negascout(depth-1,-beta,-t,posC[0],posC[1],list[i][1],list[i][2],&retlev);
      if(sollev>retlev){
        sollev=retlev;
        tmpi=i;
      }
    }
    if(a>t){
      tmpi=i;
    }
    if(a<t) a=t;
    b=a+1;                      /* set new null window */
  }  
  from=list[tmpi][0];
  to=list[tmpi][1];
  key=list[tmpi][2];
  if(key==0) slowmove=0; else slowmove++;
  //record movements
  //shift all
  for(i=CHECKSIZE-1;i>0;i--){
    loopcheck[i][0]=loopcheck[i-1][0];
    loopcheck[i][1]=loopcheck[i-1][1];
    loopcheck[i][2]=loopcheck[i-1][2];
  }
  //record at head
  loopcheck[0][0]=from;loopcheck[0][1]=to;loopcheck[0][2]=key;
  //update actively
  posC[0][key]=to;
  sortP(posC[0],key);

  printf("%d %d\n",from+1,to+1);
  fflush(stdout);
}
