/*
File name :
player3.c

Description :
This program is the main body of the program player3. player3 is 
an AI program for chinese checker playing. After initiated with
input 1 or 2 (for later version,3 to 6 are used for special
purposes)from the standard input(stdin, the key-in from console),
which specific whether to move first or the opponent move first,
the program generates movement to the standard output(stdout,
the output to the console) and read from the stdin until the game
ends.

Features :
The game flow can be divided into two stages : 
1. standard player
  Perform depth first search with the default search depth reach
  until the search space is searched. The search space is pruned
  with alpha-beta pruning.
2. end-game player
  Perform depth first search with the default end-game search
  depth until the search space is searched. The search space
  is pruned with the available solution, where solution exactly
  means the steps that confirmed able to go to the win game state.
  The optimal solutions will be learnt,i.e. recorded.

Remarks :
This program usually not runs alone, but with an graphical interface.
In linux, there is a built program that takes in two player program
for playing, ccjudge. In windows, we built a chess board for it.
The programs use pipelines to communicate with the players.

Complete file list for player3.c (in alpha-betic order) :
efunction.c
efunction.h
endgame.c
endgame.h
get.c
get.h
give.c
give.h
movegenx.c
movegenx.h
player3.c
player3.h
sort.c
sort.h
*/
/********************** imports *************************/
#include "player3.h"

/**************** function prototypes *******************/
int main(int argc, char * argv[]);
void posinit(char posC[2][10]);

/****************** function bodies *********************/
/*
function  : posinit
use       : to init the game status
argument  : char posC[2][10]
            - the status of the current game
return    : void            
*/
void posinit(char posC[2][10]){
  posC[0][0]=0;posC[0][1]=1;posC[0][2]=2;
  posC[0][3]=3;posC[0][4]=4;posC[0][5]=5;
  posC[0][6]=6;posC[0][7]=7;posC[0][8]=8;
  posC[0][9]=9;
  posC[1][0]=111;posC[1][1]=112;posC[1][2]=113;
  posC[1][3]=114;posC[1][4]=115;posC[1][5]=116;
  posC[1][6]=117;posC[1][7]=118;posC[1][8]=119;
  posC[1][9]=120;
}

void layerinit(void){
  layer[0]=1;
  layer[1]=2;layer[2]=2;
  layer[3]=3;layer[4]=3;layer[5]=3;
  layer[6]=4;layer[7]=4;layer[8]=4;layer[9]=4;
  layer[10]=5;layer[11]=5;layer[12]=5;layer[13]=5;layer[14]=5;layer[15]=5;layer[16]=5;layer[17]=5;layer[18]=5;layer[19]=5;layer[20]=5;layer[21]=5;layer[22]=5;
  layer[23]=6;layer[24]=6;layer[25]=6;layer[26]=6;layer[27]=6;layer[28]=6;layer[29]=6;layer[30]=6;layer[31]=6;layer[32]=6;layer[33]=6;layer[34]=6;
  layer[35]=7;layer[36]=7;layer[37]=7;layer[38]=7;layer[39]=7;layer[40]=7;layer[41]=7;layer[42]=7;layer[43]=7;layer[44]=7;layer[45]=7;
  layer[46]=8;layer[47]=8;layer[48]=8;layer[49]=8;layer[50]=8;layer[51]=8;layer[52]=8;layer[53]=8;layer[54]=8;layer[55]=8;
  layer[56]=9;layer[57]=9;layer[58]=9;layer[59]=9;layer[60]=9;layer[61]=9;layer[62]=9;layer[63]=9;layer[64]=9;
  layer[65]=10;layer[66]=10;layer[67]=10;layer[68]=10;layer[69]=10;layer[70]=10;layer[71]=10;layer[72]=10;layer[73]=10;layer[74]=10;
  layer[75]=11;layer[76]=11;layer[77]=11;layer[78]=11;layer[79]=11;layer[80]=11;layer[81]=11;layer[82]=11;layer[83]=11;layer[84]=11;layer[85]=11;
  layer[86]=12;layer[87]=12;layer[88]=12;layer[89]=12;layer[90]=12;layer[91]=12;layer[92]=12;layer[93]=12;layer[94]=12;layer[95]=12;layer[96]=12;layer[97]=12;
  layer[98]=13;layer[99]=13;layer[100]=13;layer[101]=13;layer[102]=13;layer[103]=13;layer[104]=13;layer[105]=13;layer[106]=13;layer[107]=13;layer[108]=13;layer[109]=13;layer[110]=13;
  layer[111]=14;layer[112]=14;layer[113]=14;layer[114]=14;
  layer[115]=15;layer[116]=15;layer[117]=15;
  layer[118]=16;layer[119]=16;
  layer[120]=17;
}
/*
function  : main
use       : the main body of player3
            - init the game with respect the init input value and
              run the entire game
arguement : int argc
            - no of arguments
            char * args[]
            - the arguments
return    : int 0
            - normal exit
*/
int main(int argc,char * argv[]){
//  int endgame=0;
  int playerid=1;
  int i;
  int tmp;
  FILE * cfg;
  char posC[2][10];

  posinit(posC);
  layerinit();
  loopcheckinit();
  endgameinit();
  readendtree();
  vsd=sd;
  turn=0;
  slowmove=0;
  //get player id
  fscanf(stdin,"%d",&playerid);

  if((playerid==3)||(playerid==4)){//read from input
    playerid-=2;
    for(i=0;i<10;i++){
      fscanf(stdin,"%d",&tmp);
      posC[0][i]=(char)tmp-1;
    }
    for(i=0;i<10;i++){
      fscanf(stdin,"%d",&tmp);
      posC[1][i]=(char)tmp-1;
    }
  }else if ((playerid==5)||(playerid==6)){//read from file
    playerid-=4;
    if(argc==2){cfg=fopen(argv[1],"r");}else{cfg=fopen(CONFIGFILE,"r");}
    if(cfg==NULL){
      printf("Configuration file not found!\n");killsubtree(root);exit(0);
    }else{
      for(i=0;i<10;i++){
        fscanf(cfg,"%d",&tmp);
        posC[0][i]=(char)tmp-1;
      }
      for(i=0;i<10;i++){
        fscanf(cfg,"%d",&tmp);
        posC[1][i]=(char)tmp-1;
      }
      fclose(cfg);
    }
  }

  if(playerid==1){                //nth is needed to do
    while(posC[0][0]<111){
      give2(posC);
      get(posC);
      turn++;
    }
  }else if(playerid==2){
    while(posC[0][0]<111){
      get(posC);
      give2(posC);
      turn++;
    }
  }else{
    printf("Error!!! playerid can only be 1 or 2!!\n");killsubtree(root);exit(0);
  }
  killsubtree(root);              //free the end-game lib, if possible
  return 0;
}