/*
File : sort.c
Description :
Part of the player3 program.
Provide functions for sorting within the program
*/

/********************** imports *************************/
#include "sort.h"

/**************** function prototypes *******************/
void swapE(char list[300][3],int mark[300],int index1,int index2);
void bubsortG(char list[300][3],int mark[300],int left,int right);
int median3(char list[300][3],int mark[300],int left,int right);
void quicksortG(char list[300][3],int mark[300],int left,int right);
void sort(char list[300][3],int mark[300],int size);
void swapP(char state[10],int index1,int index2);
void bubP(char state[10],char key);
void sinkP(char state[10],char key);
void sortP(char state[10],char key);

/****************** function bodies *********************/

void swapE(char list[300][3],int mark[300],int index1,int index2){
  int tmpi;

  for(tmpi=0;tmpi<3;tmpi++){
    list[index1][tmpi]^=list[index2][tmpi];
    list[index2][tmpi]^=list[index1][tmpi];
    list[index1][tmpi]^=list[index2][tmpi];
  }
  mark[index1]^=mark[index2];
  mark[index2]^=mark[index1];
  mark[index1]^=mark[index2];
}

void bubsortG(char list[300][3],int mark[300],int left,int right){
  int i,j;
  int tmp=right-left;
  
  for(i=0;i<tmp;i++){
    for(j=left;j<right-i;j++){
      if(mark[j]>mark[j+1]){
        swapE(list,mark,j,j+1);
      }
    }
  }
}

int median3(char list[300][3],int mark[300],
            int left,int right){
  int center=(left+right)/2;

  if (mark[left]>mark[center]){
    swapE(list,mark,left,center);
  }
  if (mark[left]>mark[right]){
    swapE(list,mark,left,right);
  }
  if (mark[center]>mark[right]){
    swapE(list,mark,center,right);
  }

  swapE(list,mark,center,right-1);//pivot hidding
  return mark[right-1];
}

void quicksortG(char list[300][3],int mark[300],
               int left,int right){
  int i,j,pivot,goon=1;
  if(left+cutoff<right){
    pivot=median3(list,mark,left,right);
    i=left;j=right-1;
    while(goon){
      while(mark[++i]<pivot){}
      while(mark[--j]>pivot){}
      if(i<j){
        swapE(list,mark,i,j);
      }else{
        goon=0;
      }
    }
    swapE(list,mark,i,right-1);
    quicksortG(list,mark,left,i-1);
    quicksortG(list,mark,i+1,right);
  }else{
    bubsortG(list,mark,left,right);
  }
}

void sort(char list[300][3],int mark[300],int size){
  //int i;
  quicksortG(list,mark,0,size-1);
  //bubsortG(list,mark,0,size-1);
  //for(i=0;i<size;i++){
    //printf("re %d\n",mark[i]);
  //}
}
void swapP(char state[10],int index1,int index2){
  state[index1]^=state[index2];
  state[index2]^=state[index1];
  state[index1]^=state[index2];
}

void bubP(char state[10],char key){
  while(key!=0){
    if(state[key]<state[key-1]){
      swapP(state,key,key-1);
      key--;
    }else{
      return;
    }
  }
}

void sinkP(char state[10],char key){
  while(key!=9){
    if(state[key]>state[key+1]){
      swapP(state,key,key+1);
      key++;
    }else{
      return;
    }
  }
}

void sortP(char state[10],char key){
  if(key==9){//check bubble
    bubP(state,key);
  }else if(key==0){//check sink
    sinkP(state,key);
  }else if(state[key]>state[key+1]){//check sink
    sinkP(state,key);
  }else if(state[key]<state[key-1]){//check bubble
    bubP(state,key);
  }
}

//void sorttest(void){
  //char list[300][3];
  //int mark[300];
  //int size=22;
  /*
  int i;
  posC[0][0]=14;posC[0][1]=60;posC[0][2]=79;
  posC[0][3]=104;posC[0][4]=111;posC[0][5]=112;
  posC[0][6]=114;posC[0][7]=116;posC[0][8]=118;
  posC[0][9]=119;
for(i=0;i<10;i++){
  printf(" %3d",posC[0][i]);
}printf("\n");

printf("insorttest\n");
sortP(posC[0],5);
for(i=0;i<10;i++){
  printf(" %3d",posC[0][i]);
}printf("\n");
*/
/*
  mark[0]=9;
  mark[1]=7;
  mark[2]=8;
  mark[3]=4;
  mark[4]=5;
  mark[5]=2;
  mark[6]=1;
  mark[7]=3;
  mark[8]=6;
  mark[9]=10;
  mark[10]=1;
  mark[11]=31;
  mark[12]=2;
  mark[13]=3;
  mark[14]=6;
  mark[15]=78;
  mark[16]=11;
  mark[17]=65;
  mark[18]=11;
  mark[19]=1;
  mark[20]=31;
  mark[21]=1;
*/
//  sort(list,mark,size);
//}
